package cn.iocoder.yudao.module.mes.service.zjschema;

import cn.iocoder.yudao.module.mes.dal.dataobject.zjitem.ZjItemDO;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.zjschema.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjschema.ZjSchemaDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.zjschema.ZjSchemaMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 检验方案 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class ZjSchemaServiceImpl implements ZjSchemaService {

    @Resource
    private ZjSchemaMapper zjSchemaMapper;

    @Override
    public Long createZjSchema(ZjSchemaSaveReqVO createReqVO) {
        // 插入
        ZjSchemaDO zjSchema = BeanUtils.toBean(createReqVO, ZjSchemaDO.class);
        zjSchemaMapper.insert(zjSchema);
        // 返回
        return zjSchema.getId();
    }

    @Override
    public void updateZjSchema(ZjSchemaSaveReqVO updateReqVO) {
        // 校验存在
        validateZjSchemaExists(updateReqVO.getId());
        // 更新
        ZjSchemaDO updateObj = BeanUtils.toBean(updateReqVO, ZjSchemaDO.class);
        zjSchemaMapper.updateById(updateObj);
    }

    @Override
    public void deleteZjSchema(Long id) {
        // 校验存在
        validateZjSchemaExists(id);
        // 删除
        zjSchemaMapper.deleteById(id);
    }

    private void validateZjSchemaExists(Long id) {
        if (zjSchemaMapper.selectById(id) == null) {
            throw exception(ZJ_SCHEMA_NOT_EXISTS);
        }
    }

    @Override
    public ZjSchemaDO getZjSchema(Long id) {
        return zjSchemaMapper.selectById(id);
    }

    @Override
    public PageResult<ZjSchemaDO> getZjSchemaPage(ZjSchemaPageReqVO pageReqVO) {
        return zjSchemaMapper.selectPage(pageReqVO);
    }

    @Override
    public List<ZjSchemaDO> getZjSchemaList() {
        return zjSchemaMapper.selectList();
    }

}